CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

        BTR     =     2048   ' Packet size
        
obj
'   term: "tv_text"
   sdfat: "fsrw"
   mast : "Master"
   slav : "Slave"      
      
var
   byte Buffer[8192]
   byte Fbuff[3]        ' Four flags to check the sub-buffers states.

   long w
   long y
   long writepos        ' where in the ring buffer to start writing (the SD routine)
   long readpos         ' where in the ring buffer to start reading (the slave)
   long ringstart       ' the start of the big ring buffer
   long ringend         ' the end of the big ring buffer

pub go | x
   x := \start
   
pub start | r, sta, bytes

   ringstart := @Buffer
   readpos   := @Fbuff
   ringend   := @Buffer + 6144
   Fbuff[0] := 0
   Fbuff[1] := 0
   Fbuff[2] := 0
   Fbuff[3] := 0

   sdfat.mount(0)
   mast.start(readpos,ringstart)
'   slav.start    ' In this demo I can't activate it because just the same I/O's of Master...I don't know how to test it ... 
'**********************************************************************
   r := sdfat.popen(string("B.btx"), "r")
'**********************************************************************

'**********************************************************************
   writepos := 0
   w        := 0
   r        := BTR
   
   repeat while r == BTR                  ' This repeat value must be calculated taking info of the file to be send.
      y := Fbuff[w]                       ' The file must contain a number of bytes multiple of 2048
      if y == 0
        writepos := ringstart +(w * BTR)  ' Address to start save the data
        r := sdfat.pread(writepos, BTR)   ' Read the SD file.
        Fbuff[w++] := 1                   ' Put the sub-buffer into the 'permision read' state  (For 'Master' rutine)
      if writepos == ringend              ' If the big Buffer is full, loop and wait to the first sub-buffer
                                          ' to be enable for write again (Master rutine will enable it,after send the data to some slave) 
        w := 0

repeat

   '' I test more or less 368Kb of speed with this repeat loop
'**********************************************************************

   